/*

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish and distribute.
  
  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
  AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
  AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  Copyright 1999 -   Laurent Balmelli
                     Laboratory For Audio-Visual Communications 
                     Ecole Polytechnique Federale de Lausanne, Switzerland

                     also:
                     Mathematics for Communication, Bell Laboratories
                     Lucent Technologies, USA

  contact, bugs:     Laurent.Balmelli@epfl.ch
                     balmelli@research.bell-labs.com
                     
  PLEASE DO NOT REMOVE THIS COPYRIGHT NOTICE. 
                     
 */

import java.net.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import java.applet.*;
//import wcoder.jar.*;

// TODO
// replace int HaveImage by boolean value
// Test if image cannot be loaded

/*public*/ class ShowImage extends java.applet.Applet 
{

	Image OriginalImage,
	      Analysis,
	      Synthesis,
	      Transform,
	      Projection;

	int imageWidth,
	    imageHeight; 

	boolean stop_reset,
		image_change;
	int     last_image;

	int   TransformInt[];
	int   level;
	int   maxlevel;

	TextField G0,G1,H0,H1,Delay;

	MediaTracker tracker;
	URL url_image;
	double signal[];
	int imageData[];
  //WTransform Wavelet;
	
	ImageDisplay Original,
		     deco1,
		     deco2,
		     Coefficients,
		     Reconstruction;

	Panel     Displays,
		     AfilterDisplay,
		     SfilterDisplay;
		
	CommandPanel2 FilterPanel;
	
	Filter bank;
    
        // Filters

        double h0[] = new double[3];  double g0[] = new double[5];
        double h1[] = new double[5];  double g1[] = new double[3];

	int HaveImage;
	Font f = new Font("TimesRoman",Font.BOLD,15);

	public void init() {
		
		setBackground(Color.white);
		
		stop_reset = false;
		image_change = true;
		last_image = 1;

		level = 0;

		//String ImageName = getParameter("image");
		//System.err.println(ImageName);
		String ImageName = "images/lena.gif";
		
		try {
		   url_image = new URL(ImageName);
		} catch (MalformedURLException malFormedURL)
		        {
		        }
		
		tracker = new MediaTracker(this);

		if (ImageName == null) {
			HaveImage = 0;
			System.err.println("Could not load image");
		}
		else {
			HaveImage = 1;
			OriginalImage = getImage(getCodeBase(),
			       	       ImageName);
			tracker.addImage(OriginalImage,0); 
			
			try { 
			   tracker.waitForID(0);
		 	} catch (InterruptedException interruptLoad) 
				 { // Handle exception
				 }

			imageWidth = OriginalImage.getWidth(this);
		 	imageHeight = OriginalImage.getHeight(this);

			Analysis = getImage(getCodeBase(),
			       	            "images/analysis.gif");
			tracker.addImage(Analysis,0); 
			
			try { 
			   tracker.waitForID(0);
		 	} catch (InterruptedException interruptLoad) 
				 { // Handle exception
				 }

			Synthesis = getImage(getCodeBase(),
			       	            "images/synthesis.gif");
			tracker.addImage(Synthesis,0); 
			
			try { 
			   tracker.waitForID(0);
		 	} catch (InterruptedException interruptLoad) 
				 { // Handle exception
				 }

			//Wavelet = new WTransform(OriginalImage,imageWidth,OriginalImage.getHeight(this));

			Original = new ImageDisplay(128,128);
			Original.titleString = "Original Image";
			Original.plot(OriginalImage);

			deco1 = new ImageDisplay(74,113);
			deco1.BOX = false;
			deco1.plot(Analysis);
			
			Coefficients = new ImageDisplay(128,128);
			Coefficients.titleString = "Coefficients";

			deco2 = new ImageDisplay(74,113);
			deco2.BOX = false;
			deco2.plot(Synthesis);

			Reconstruction = new ImageDisplay(128,128);
			Reconstruction.titleString = "Reconstruction";

		        AfilterDisplay = new Panel();
	  		AfilterDisplay.setLayout(new BorderLayout());
		        SfilterDisplay = new Panel();
	  		SfilterDisplay.setLayout(new BorderLayout());
			
			H0 = new TextField("",10);
			H1 = new TextField("",10);
		     	G0 = new TextField("",10);
			G1 = new TextField("",10);
			Delay = new TextField("",1);		

			AfilterDisplay.add("North",H0);
			//AfilterDisplay.add("Center",deco1);
			//AfilterDisplay.add("South",H1);

			SfilterDisplay.add("North",G0);
			//SfilterDisplay.add("Center",deco2);
			//SfilterDisplay.add("South",G1);
			//SfilterDisplay.add("East",Delay);

			Displays = new Panel();
			//Displays.add(Original);
			Displays.add(AfilterDisplay);
			//Displays.add(Coefficients);	
			Displays.add(SfilterDisplay);
			Displays.add(Delay);
			//Displays.add(Reconstruction);
				
	
			FilterPanel = new CommandPanel2();
			
                        setLayout(new BorderLayout());
		
  	  		add("Center",Displays);
			//add("South",FilterPanel);	
		}

		//
		// Setting the default filter
		//
		
		double h0[],h1[],g0[],g1[];
		int delay;
		h0 = new double[3];
		g0 =new double[1];
		g1=new double[1];
		h1=new double[1];
		h0[0]=0.25; h0[1]=0.75; h0[2]=0.25;
		h1[0]=0.25; g0[0]=0.25; g1[0]=0.25;

		h0 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_H0,
					 "h0 filter set");	
		h1 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_H1,
					 "h1 filter set");
 		g0 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_G0,
					 "g0 filter set");
		g1 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_G1,
					 "g1 filter set");
		delay = FilterPanel.LIN_SPLINE_FILTER_DELAY;
				
		//System.err.println("h0 = "+h0[0]);

		initFilterBank(h0,h1,g0,g1,delay);
		
	}

	public void initFilterBank(double h0[], double h1[], double g0[], double g1[], int delay) {

		bank = new Filter(OriginalImage,imageWidth,imageHeight);
                

		// Initialize filters				
		
		G0.setText(getFilterFromDouble(g0));
		G1.setText(getFilterFromDouble(g1));
		H0.setText(getFilterFromDouble(h0));
		H1.setText(getFilterFromDouble(h1));
		
		Integer d = new Integer(delay);
		Delay.setText(d.toString());
		
		bank.setFilter(Filter.H0,h0);
		bank.setFilter(Filter.H1,h1);
		bank.setFilter(Filter.G0,g0);
		bank.setFilter(Filter.G1,g1);
		bank.setFilterDelay(delay);
		
		double tmp1 = Math.min((double)imageWidth,(double)imageHeight);
		double tmp2 = Math.log(tmp1);
		double tmp3 = Math.log(2.0);
		maxlevel = (int)(tmp2/tmp3);

		FilterPanel.resetSubbandChoice();
		
	}


	public boolean /*action*/ActinListener(Event evt, Object arg) {
	
	   if ( evt.target instanceof Button ) 
	   {
		
		if ( (((String)arg).compareTo(CommandPanel2.ANALYSIS_BUTTON)) == 0 )
                {
		
		   if ( level < maxlevel) {
	             Vector result;			

		     int NewimageWidth   = (int)(((double)imageWidth)/Math.pow(2.0,(double)level));
		     int NewimageHeight  = (int)(((double)imageHeight)/Math.pow(2.0,(double)level));

		     FilterPanel.print("Analysis filter bank started: filtering "+NewimageWidth+"x"+NewimageHeight+" signal...please wait");
		     TransformInt  = bank.analysis(0,0,NewimageWidth,NewimageHeight,ImageConverter.ENHANCE,level+1);

		     Transform =  this.createImage(new MemoryImageSource(imageWidth,
					  	    		         imageHeight,
							                 TransformInt,
									 0,
							                 imageWidth));
		     tracker.addImage(Transform,1);
		     try {
	   		  tracker.waitForID(1);
		     } catch (Exception e) {return true;}

		     Coefficients.erase(0);
		     Coefficients.plot(Transform);

		     FilterPanel.print("Analysis operation completed.");
		     FilterPanel.levelPlus();
		     level++;
		 	
		    }
		    else {
		      FilterPanel.clearText();	
	              FilterPanel.print("The maximum level of decomposition has been reached, sorry.");
		    }
		      repaint();
		}
		else FilterPanel.print("The maximum level of decomposition has been reached for this signal.");
		
		if ( (((String)arg).compareTo(CommandPanel2.SYNTHESIS_BUTTON)) == 0 )
                {
		   if ( level != 0 ) {
		      level--;

		      int NewimageWidth   = (int)(((double)imageWidth)/Math.pow(2.0,(double)level));
		      int NewimageHeight  = (int)(((double)imageHeight)/Math.pow(2.0,(double)level));
			
		      FilterPanel.clearText();
		      FilterPanel.print("Synthesis filter bank started: filtering "+NewimageWidth+"x"+NewimageHeight+" signal...please wait");
		      
		      int r[] = FilterPanel.getSubbandChoice();
			      
		      // subband choice
		
		      if ( !(FilterPanel.ll.getState()) )
			 bank.clearBand(0,0,NewimageWidth/2,NewimageHeight/2);

		      if ( !(FilterPanel.lh.getState()) )
			 bank.clearBand(NewimageWidth/2,0,NewimageWidth,NewimageHeight/2);

		      if ( !(FilterPanel.hl.getState()) )
			 bank.clearBand(0,NewimageHeight/2,NewimageWidth/2,NewimageHeight);

	              if ( !(FilterPanel.hh.getState()) )
			 bank.clearBand(NewimageWidth/2,NewimageHeight/2,NewimageWidth,NewimageHeight);	
		

		      if ( level > 0 ) {
			TransformInt = 
			  bank.synthesis(0,0,NewimageWidth,NewimageHeight,Filter.PR,Filter.PR,ImageConverter.ENHANCE,level);

   			  Transform =  this.createImage(new MemoryImageSource(imageWidth,
					    	    		              imageHeight,
							                      TransformInt,0,
							                      imageWidth));
			  tracker.addImage(Transform,1);
		      	  try {
	   		    tracker.waitForID(1);
		          } catch (Exception e) {return true;}

			  Coefficients.erase(0);		// delete preceding image
			  Coefficients.plot(Transform);	  
			  FilterPanel.print("Synthesis operation completed.");		
	
		     }	else {
			
			int mode = ImageConverter.REAL;
	
			if ( FilterPanel.enhance.getState() )
			   mode = ImageConverter.ENHANCE;

		        TransformInt =
			  bank.synthesis(0,0,NewimageWidth,NewimageHeight,Filter.PR,Filter.PR,mode,level);

			  Projection = 	this.createImage(new MemoryImageSource(imageWidth,
					    	    		              imageHeight,
							                      TransformInt,0,
							                      imageWidth));
			  tracker.addImage(Projection,1);
		          try {
	   		    tracker.waitForID(1);
		          } catch (Exception e) {return true;}

			  Coefficients.erase(0);		// delete preceding image
			  Reconstruction.erase(0);		// delete preceding image
			  Reconstruction.plot(Projection);	  
			  FilterPanel.print("Reconstructed signal available!");
		     }	
		     
	
		     FilterPanel.levelMinus();
		     Coefficients.repaint();
		     Reconstruction.repaint();
		   }
		   else FilterPanel.print("No coefficients available, perform some analysis steps before.");
	
		}

		if ( (((String)arg).compareTo(CommandPanel2.RESET_BUTTON)) == 0 )
                {
			level = 0;

			Coefficients.erase(0);
			Reconstruction.erase(0);
				
			FilterPanel.levelReset();

			FilterPanel.clearText();
		        FilterPanel.print("The filter bank is now ready for analysis.");
	
			double h0[],h1[],g0[],g1[];
			int delay = 0,fc;
			Integer d;
				
			fc = FilterPanel.filters.getSelectedIndex();
		
			switch(fc) {

			  case 1:	// Haar
		
			    h0 = getFilterFromString(FilterPanel.HAAR_FILTER_H0,"h0 filter set");	
			    h1 = getFilterFromString(FilterPanel.HAAR_FILTER_H1,"h1 filter set");
 			    g0 = getFilterFromString(FilterPanel.HAAR_FILTER_G0,"g0 filter set");
			    g1 = getFilterFromString(FilterPanel.HAAR_FILTER_G1,"g1 filter set");
			    delay = FilterPanel.HAAR_FILTER_DELAY;	

		   	  break;
	 	 
			  case 0:	// Linear
	
			    h0 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_H0,"h0 filter set");	
			    h1 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_H1,"h1 filter set");
 			    g0 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_G0,"g0 filter set");
			    g1 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_G1,"g1 filter set");
			    delay = FilterPanel.LIN_SPLINE_FILTER_DELAY;

		   	  break;	

		   	  case 2:	// Quad

			    h0 = getFilterFromString(FilterPanel.QUAD_SPLINE_FILTER_H0,"h0 filter set");	
			    h1 = getFilterFromString(FilterPanel.QUAD_SPLINE_FILTER_H1,"h1 filter set");
 			    g0 = getFilterFromString(FilterPanel.QUAD_SPLINE_FILTER_G0,"g0 filter set");
			    g1 = getFilterFromString(FilterPanel.QUAD_SPLINE_FILTER_G1,"g1 filter set");
			    delay = FilterPanel.QUAD_SPLINE_FILTER_DELAY;

		   	  break;

			  case 3:	// Coiffman

			    h0 = getFilterFromString(FilterPanel.COIFFMANN_FILTER_H0,"h0 filter set");		
			    h1 = getFilterFromString(FilterPanel.COIFFMANN_FILTER_H1,"h1 filter set");
 			    g0 = getFilterFromString(FilterPanel.COIFFMANN_FILTER_G0,"g0 filter set");
			    g1 = getFilterFromString(FilterPanel.COIFFMANN_FILTER_G1,"g1 filter set");
			    delay = FilterPanel.COIFFMANN_FILTER_DELAY;
	
		   	  break;
		
			  default:	// Custom
			
			    h0 = getFilterFromString(H0.getText(),"h0 filter set");	
			    h1 = getFilterFromString(H1.getText(),"h1 filter set");
 			    g0 = getFilterFromString(G0.getText(),"g0 filter set");
			    g1 = getFilterFromString(G1.getText(),"g1 filter set");
	
			    d = new Integer(Delay.getText());
			    if ( d.intValue() < 0 ) stop_reset = true;
			    else delay = d.intValue();	

			  break;
		 	}
		
			initFilterBank(h0,h1,g0,g1,delay);

			Coefficients.repaint();
			Reconstruction.repaint();
		}

	   }

	   if ( evt.target instanceof Choice ) 
	   {
	       //System.err.println(arg.toString());
	       // System.err.println(evt.toString());

		stop_reset = false;

		String file = "images/lena.gif";
		int fc = 2;
		
		if ( last_image != FilterPanel.seq.getSelectedIndex() ) image_change = true;

		last_image = FilterPanel.seq.getSelectedIndex();
	
		if ( FilterPanel.seq.getSelectedItem().compareTo(FilterPanel.LENA) == 0 ) 	
		  file = FilterPanel.LENA_FILE;
		
		if ( FilterPanel.seq.getSelectedItem().compareTo(FilterPanel.BABOON) == 0 ) 
		  file = FilterPanel.BABOON_FILE;

		if ( FilterPanel.seq.getSelectedItem().compareTo(FilterPanel.LADY) == 0 ) 
		  file = FilterPanel.LADY_FILE;

		if ( FilterPanel.seq.getSelectedItem().compareTo(FilterPanel.AERIAL) == 0 ) 
		  file = FilterPanel.AERIAL_FILE;

		if ( FilterPanel.seq.getSelectedItem().compareTo(FilterPanel.ANEMONE) == 0 ) 
		  file = FilterPanel.ANEMONE_FILE;

		if ( FilterPanel.seq.getSelectedItem().compareTo(FilterPanel.CAMERAMAN) == 0 ) 
		  file = FilterPanel.CAMERAMAN_FILE;

		if ( FilterPanel.seq.getSelectedItem().compareTo(FilterPanel.TIFFANY) == 0 ) 
		  file = FilterPanel.TIFFANY_FILE;
		
		//
		// Filter choice
		//

		fc = FilterPanel.filters.getSelectedIndex();
				
		double h0[],h1[],g0[],g1[];
		int    delay = 0;
		Integer d;

		switch(fc) {

		  case 1:	// Haar

		    h0 = getFilterFromString(FilterPanel.HAAR_FILTER_H0,"h0 filter set");	
		    h1 = getFilterFromString(FilterPanel.HAAR_FILTER_H1,"h1 filter set");
 		    g0 = getFilterFromString(FilterPanel.HAAR_FILTER_G0,"g0 filter set");
		    g1 = getFilterFromString(FilterPanel.HAAR_FILTER_G1,"g1 filter set");
		    delay = FilterPanel.HAAR_FILTER_DELAY;

	   	  break;
	 	 
		  case 0:	// Linear

		    h0 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_H0,"h0 filter set");	
		    h1 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_H1,"h1 filter set");
 		    g0 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_G0,"g0 filter set");
		    g1 = getFilterFromString(FilterPanel.LIN_SPLINE_FILTER_G1,"g1 filter set");
		    delay = FilterPanel.LIN_SPLINE_FILTER_DELAY;

	   	  break;

	   	  case 2:	// Quad

		    h0 = getFilterFromString(FilterPanel.QUAD_SPLINE_FILTER_H0,"h0 filter set");	
		    h1 = getFilterFromString(FilterPanel.QUAD_SPLINE_FILTER_H1,"h1 filter set");
 		    g0 = getFilterFromString(FilterPanel.QUAD_SPLINE_FILTER_G0,"g0 filter set");
		    g1 = getFilterFromString(FilterPanel.QUAD_SPLINE_FILTER_G1,"g1 filter set");
		    delay = FilterPanel.QUAD_SPLINE_FILTER_DELAY;

	   	  break;

		  case 3:	// Coiffman

		    h0 = getFilterFromString(FilterPanel.COIFFMANN_FILTER_H0,"h0 filter set");	
		    h1 = getFilterFromString(FilterPanel.COIFFMANN_FILTER_H1,"h1 filter set");
 		    g0 = getFilterFromString(FilterPanel.COIFFMANN_FILTER_G0,"g0 filter set");
		    g1 = getFilterFromString(FilterPanel.COIFFMANN_FILTER_G1,"g1 filter set");
		    delay = FilterPanel.COIFFMANN_FILTER_DELAY;

	   	  break;
		
		  default:	// Custom
			
		    h0 = getFilterFromString(H0.getText(),"h0 filter set");	
		    h1 = getFilterFromString(H1.getText(),"h1 filter set");
 		    g0 = getFilterFromString(G0.getText(),"g0 filter set");
		    g1 = getFilterFromString(G1.getText(),"g1 filter set");
	
		    d = new Integer(Delay.getText());
		    if ( d.intValue() < 0 ) stop_reset = true;
		    else delay = d.intValue();

		  break;
	 	}

		if ( !stop_reset ) {	// Filter syntaxe error

		   if ( image_change ) {

			FilterPanel.print("Loading new image...please wait");

			OriginalImage = getImage(getCodeBase(),
			       	         file);
			tracker.addImage(OriginalImage,0); 
			
			try { 
		   	   tracker.waitForID(0);
		 	} catch (InterruptedException interruptLoad) 
			{ // Handle exception
			}

			imageWidth = OriginalImage.getWidth(this);
			imageHeight = OriginalImage.getHeight(this);

			image_change = false;

		   }

		   level = 0;

		   Original.erase(0);
		   Coefficients.erase(0);
		   Reconstruction.erase(0);
				
		   FilterPanel.levelReset();
	   	   FilterPanel.clearText();
		
		   Original.plot(OriginalImage);
		   initFilterBank(h0,h1,g0,g1,delay);

		   FilterPanel.print("The filter bank is now ready for analysis.");
		}

		Original.repaint();
		Coefficients.repaint();
		Reconstruction.repaint();

		
	   }

	    
	   return true;
	}

	private static final String NULL_STRING = "";


	public double[] getFilterFromString(String filter, String message) {

		String coeff;
		int i;
		Double c;
		Vector Vcoeff = new Vector();		

		filter.trim();

		while ( (i = filter.lastIndexOf(",")) > 0 ) {
	
		   coeff = filter.substring(i+1);
		
		   if ( coeff.compareTo(NULL_STRING) != 0 ) 
		   {
			c = new Double(coeff);
		   	filter = filter.substring(0,i);   
		   } 	
		   else {
		     FilterPanel.print("Syntax error! Please check filter syntaxe. ex: 1,2,1");
		     stop_reset = true;
		     return null;
		   }

		   Vcoeff.addElement(c);
		}
		c = new Double(filter);	
		Vcoeff.addElement(c);

		// convert into array

		int l = Vcoeff.size();
		double res[] = new double[l];

		for ( i = 0; i < l; i++ ) 
		  res[i] = ((Double)(Vcoeff.elementAt(i))).doubleValue();
		
		FilterPanel.print(message);

		return res;
	}

	public String getFilterFromDouble(double f[]) {

	   Double c;	
	   String res ="";
	   int l = f.length;

	   for ( int i=0; i < l; i++ ) {

		c = new Double(f[i]);
		res += c.toString();
			
		if ( i < l-1 ) 
		  res += ","; 
	   }
	  return res;
	}

}
