/*

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish and distribute.
  
  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
  AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
  AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  Copyright 1999 -   Laurent Balmelli
                     Laboratory For Audio-Visual Communications 
                     Ecole Polytechnique Federale de Lausanne, Switzerland

                     also:
                     Mathematics for Communication, Bell Laboratories
                     Lucent Technologies, USA

  contact, bugs:     Laurent.Balmelli@epfl.ch
                     balmelli@research.bell-labs.com
                     
  PLEASE DO NOT REMOVE THIS COPYRIGHT NOTICE. 
                     
 */


//
//

import java.net.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;

class CommandPanel2 extends Panel
{
 
   
   GridBagLayout gridBag;
  
   public Checkbox ll,lh,hl,hh;

   public Checkbox enhance;
   
   //
   // components accessible from outside
   //
   public TextField 	display2;
   public TextField  	a_val; 
   public Choice 	seq,filters;

   int Textline;				// Position in the text Label
   private final static String BLANK = " ";		

   private int 		level; 
   private Integer 	levelI;

   private TextField    levelS;

    public CommandPanel2()
    {
	gridBag = new GridBagLayout();
	setLayout(gridBag);
	setFont(new Font("Helvetica", Font.PLAIN,12));

	Textline = 0;
	level = 0;
	levelI = new Integer(level);	
	
 	makeButtonPanel();
    }

    public Dimension getMinimumSize() {
	return new Dimension(400,100);
    }

    public Dimension getPreferredSize() {
	return getMinimumSize();
    }

    public void paint(Graphics g)
    {

    }

    public void panelWarning(String warn) {
	
	//clearText();
	//display.insertText(warn);

    }	
    
    // Button Names
    
    public final static String ANALYSIS_BUTTON  = "analisi";
    public final static String SYNTHESIS_BUTTON  = "sintesi"; 
    public final static String RESET_BUTTON  = "reset";

    // Label Names
   
    public final static String A_LABEL  = "a =";
    public final static String COMMAND_LABEL  = "Immagine";
    //public final static String CHECKBOX_LABEL  = "Reconstruction bands"; 
    public final static String CHECKBOX_LABEL   = "Subands"; 
    public final static String CHECKBOX_LABEL2  = "Effect"; 

    public final static String OPERATION_LABEL  = "Messaggi: ";
	 
    // Choices 

    public final static String LOWLOW  	= "LL";
    public final static String LOWHIGH  = "LH";
    public final static String HIGHLOW  = "HL";	
    public final static String HIGHHIGH = "HH";	
    public final static String ENHANCE  = "enhance";

    // Images

    public final static String LENA  	   = "Paesaggio 1";
    public final static String BABOON      = "Napoli";
    public final static String LADY	       = "Aerea";
    public final static String AERIAL	   = "Bordeaux 1";
    public final static String ANEMONE	   = "Paesaggio 2";
    public final static String CAMERAMAN   = "Parigi";
    public final static String TIFFANY     = "Bordeaux 2";

    public final static String LENA_FILE        = "images/Immagine7.gif";
    public final static String BABOON_FILE      = "images/Immagine1.gif";	
    public final static String LADY_FILE    	= "images/Immagine2.gif";
    public final static String AERIAL_FILE	    = "images/Immagine3.gif";
    public final static String ANEMONE_FILE	    = "images/Immagine4.gif";
    public final static String CAMERAMAN_FILE   = "images/Immagine5.gif";
    public final static String TIFFANY_FILE     = "images/Immagine6.gif";
 

    // Filter 

    public final static String HAAR		= "Haar";
    public final static String LIN_SPLINE	= "Lin.Spline";
    public final static String QUAD_SPLINE	= "Quad.Spline"; 
    public final static String COIFFMANN	= "Coiffman";
    public final static String CUSTOM		= "Custom";	
    		
    public final static String HAAR_FILTER_H0	     = "0.7071,0.7071";
    public final static String HAAR_FILTER_H1	     = "-0.7071,0.7071";
    public final static String HAAR_FILTER_G0	     = "0.7071,0.7071";
    public final static String HAAR_FILTER_G1	     = "0.7071,-0.7071";
    public final static int    HAAR_FILTER_DELAY     = 1;

    public final static String LIN_SPLINE_FILTER_G0    = "0.25,0.5,0.25";
    public final static String LIN_SPLINE_FILTER_G1    = "-0.25,-0.5,1.5,-0.5,-0.25";
    public final static String LIN_SPLINE_FILTER_H0    = "-0.25,0.5,1.5,0.5,-0.25";
    public final static String LIN_SPLINE_FILTER_H1    = "-0.25,0.5,-0.25";
    public final static int    LIN_SPLINE_FILTER_DELAY = 3; 

    public final static String QUAD_SPLINE_FILTER_H0    = "-0.25,0.75,0.75,-0.25";
    public final static String QUAD_SPLINE_FILTER_H1    = "-0.25,0.75,-0.75,0.25"; 
    public final static String QUAD_SPLINE_FILTER_G0    = "0.25,0.75,0.75,0.25";
    public final static String QUAD_SPLINE_FILTER_G1    = "-0.25,-0.75,0.75,0.25";
    public final static int    QUAD_SPLINE_FILTER_DELAY = 3; 	


    public final static String COIFFMANN_FILTER_H0    = "0.05456145913814,-0.17956145913770,-0.10912291827626,0.85912291827640,1.05456145913750,0.32043854086198";
    public final static String COIFFMANN_FILTER_H1    = "0.05456145913814,0.17956145913770,-0.10912291827626,-0.85912291827640,1.05456145913750,-0.32043854086198";
    public final static String COIFFMANN_FILTER_G0    = "0.05456145913814,-0.17956145913770,-0.10912291827626,0.85912291827640,1.05456145913750,0.32043854086198";
    public final static String COIFFMANN_FILTER_G1    = "-0.05456145913814,-0.17956145913770,0.10912291827626,0.85912291827640,-1.05456145913750,0.32043854086198";
    public final static int    COIFFMANN_FILTER_DELAY = 4;

    private void makeButtonPanel()
    { 
	// CONSTRAINTS
	GridBagConstraints c = new GridBagConstraints();

	c.fill = GridBagConstraints.BOTH;
        c.weightx = 0.0;  
	
	// LABEL
	//Label comm = new Label(COMMAND_LABEL);
	//gridBag.setConstraints(comm,c);	
	//add(comm);

	// CHOICES
	filters = new Choice();
	filters.addItem(LIN_SPLINE);
 	filters.addItem(HAAR);
	filters.addItem(QUAD_SPLINE);
	filters.addItem(CUSTOM);

	gridBag.setConstraints(filters,c);
	add(filters);	

	// BUTTON FILTER
	Button anal= new Button(ANALYSIS_BUTTON);
	gridBag.setConstraints(anal,c);
	add(anal);

	levelS = new TextField(levelI.toString(),1);
	levelS.setEditable(false);
	gridBag.setConstraints(levelS,c);
	add(levelS);
	
	Button synt = new Button(SYNTHESIS_BUTTON);
	gridBag.setConstraints(synt,c);
	add(synt);

	Label comm2 = new Label(CHECKBOX_LABEL);
	gridBag.setConstraints(comm2,c);	
	add(comm2);

        ll = new Checkbox(LOWLOW,null,true);
        gridBag.setConstraints(ll,c);
	add(ll);

	lh = new Checkbox(LOWHIGH,null,true);
        gridBag.setConstraints(lh,c);
	add(lh);
	
	hl = new Checkbox(HIGHLOW,null,true);
        gridBag.setConstraints(hl,c);
	add(hl);
	
	hh = new Checkbox(HIGHHIGH,null,true);
        gridBag.setConstraints(hh,c);
	add(hh);
	
	//
	//	Image Effects
	//

	Label comm3 = new Label(CHECKBOX_LABEL2);
	gridBag.setConstraints(comm3,c);	
	add(comm3);

	enhance = new Checkbox(ENHANCE,null,false);
	gridBag.setConstraints(enhance,c);
	add(enhance);

	c.gridwidth = GridBagConstraints.REMAINDER;

	// BUTTON CLEAR
	Button clear = new Button(RESET_BUTTON);
	gridBag.setConstraints(clear,c);
	add(clear);

	c.weightx = 0.0;
	c.gridwidth = 1;
	// IMAGE CHOICE

	seq = new Choice();
        seq.addItem(LENA);
        seq.addItem(BABOON);
        seq.addItem(LADY);
  	seq.addItem(AERIAL); 
	seq.addItem(ANEMONE); 
	seq.addItem(CAMERAMAN);
	seq.addItem(TIFFANY); 

	gridBag.setConstraints(seq,c);
	add(seq);
        
	// TEXT AREA
	Label display1 = new Label(OPERATION_LABEL);	
	gridBag.setConstraints(display1,c);
	add(display1);

	c.gridwidth = GridBagConstraints.REMAINDER;

	display2 = new TextField("",60);	
	display2.setEditable(false);

	gridBag.setConstraints(display2,c);
	add(display2);

    }

    public void levelPlus() {
	
	level++;
	levelI = new Integer(level);
	levelS.setText(levelI.toString());	
		
    }	


    public void levelMinus() {
	
	level--;
	levelI = new Integer(level);
	levelS.setText(levelI.toString());		 
	 	 
    }

    public void levelReset() {
	
	level = 0;
	levelI = new Integer(level);
	levelS.setText(levelI.toString());

    }

    public void clearText() {
		 
	display2.setText("");

    }	

    public void print(String text) {

	display2.setText(text);
	 
    }

    public int[] getSubbandChoice() {

	boolean res[] = new boolean[4];
	int r[] = new int[2];

	res[0]= ll.getState();
	res[1]= hl.getState();
	res[2]= lh.getState();	
	res[3]= hh.getState();

	if (( res[0] && res[1]) || ( res[2] && res[3])) r[0] = Filter.PR;	
	else if ( res[0] || res[2] ) r[0] = Filter.L;
	else r[0] = Filter.H;

	if (( res[0] && res[2]) || ( res[1] && res[3])) r[1] = Filter.PR;
	else if ( res[0] || res[1] ) r[1] = Filter.L;
	else r[1] = Filter.H;
	
	return r;

    }

    public void resetSubbandChoice() {	
	
	ll.setState(true);
	hl.setState(true);
	lh.setState(true);
	hh.setState(true);
	enhance.setState(false);
    }
}
